<template>
	<f7-page name="announcementdetail" @page:beforein="onPageBeforeIn" @page:beforeout="onPageBeforeOut">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title v-if="announcement && announcement.category" class="show-small-title">{{ announcement.category.name }}</f7-nav-title>
            <f7-nav-title-large v-if="announcement && announcement.category">{{ announcement.title }}</f7-nav-title-large>
            <f7-nav-right v-if="announcement != null">
                <f7-link :href="`/announcements/view/${announcement.id}/comments/`">
                    <f7-icon ios="f7:chat" aurora="f7:chat" md="f7:chat" class="icon f7-icons">
					    <f7-badge color="red">{{ announcement.total_comment.kformat() }}</f7-badge>					
				    </f7-icon>
                </f7-link>
            </f7-nav-right>
		</f7-navbar>
        <f7-block v-if="announcement && announcement.category">
            <strong class="display-block">{{ announcement.residentials[0].administrative_region[2].replace(/(Kota|Kab)/g, '')+', '+dateFormat(announcement.updated, 'DD MMMM YYYY') }}</strong>
            <br>
            <ul style="list-style:none;padding-left:0;">
                <li>
                    <strong style="display:block;width:100px;margin-right:10px;float:left">No</strong>: {{ announcement.number }}
                </li>
                <li>
                    <strong style="display:block;width:100px;margin-right:10px;float:left">Perihal</strong>: {{ announcement.title }}
                </li>
                <li>
                    <strong style="display:block;width:100px;margin-right:10px;float:left">Lampiran</strong>: {{ announcement.medias.length > 0 ? announcement.medias.length : '-' }}
                </li>
            </ul>
            <br>
            <p>Kepada Yth. <br> Warga {{ announcement.residentials[0].name }}<br>{{ announcement.residentials[0].address }}, {{ announcement.residentials[0].administrative_region[0] }}, {{ announcement.residentials[0].administrative_region[1] }}, <br>{{ announcement.residentials[0].administrative_region[2] }}, {{ announcement.residentials[0].administrative_region[3] }}, {{ announcement.residentials[0].administrative_region[4] }}</p>
            <br>
            <div v-html="announcement.body">
                {{ announcement.body }}
            </div>
            <br>
            <f7-row v-if="announcement.signs.length > 0">
                <f7-col v-for="sign in announcement.signs" v-bind:key="sign.id">
                    <u>{{ sign.name }}</u><br>{{ sign.position }}
                </f7-col>
            </f7-row>
            <br>
            <h3 v-if="announcement.medias != null"><f7-icon f7="attachment"></f7-icon> Lampiran</h3>
            <ul v-if="announcement.medias != null"  style="list-style:none;padding-left:0;">
                <li v-for="media in announcement.medias" v-bind:key="media.id" style="border-top:1px solid #eee;padding-top:10px;padding-bottom: 10px;">
                    <f7-button v-if="['image/jpg', 'image/jpeg', 'image/png'].indexOf(media.mimetype) > -1" color="smoothgray" @click="showMedia(announcement)" class="text-align-left"> 
                        <f7-icon size="18" f7="images" class="margin-small-right"></f7-icon> 
                        {{ media.original_filename }}
                    </f7-button>
                    <f7-button v-else :href="media.url" :download="media.url" external color="smoothgray"> 
                        <f7-icon size="18" f7="document_text" class="margin-small-right"></f7-icon>
                        {{ media.original_filename }}
                    </f7-button>
                </li>
            </ul>
        </f7-block>
	</f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { hoursAgo, dateFormat, truncate, stripHTML, slugify } from '../js/utils';
export default {
    name: 'AnnouncementDetail',
    data(){
        return {};
    },
    computed: {
        ...mapGetters('auth', ['user']),
		...mapGetters('announcement', [
			'announcement'
		])
    },
    methods: {
        dateFormat,
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;

            app.preloader.show('green');

            self.$store.dispatch('announcement/viewAnnouncement', {
                id: self.$f7route.params.id,
                only: 'id,number,title,body,created,updated,category.id,category.name,medias.mimetype,medias.url,medias.filename,medias.original_filename,signs,residentials.name,residentials.address,residentials.administrative_region,author.id,author.profile.fullname,author.profile.initial,author.profile.media,total_comment'
            }).then(() => {
                app.preloader.hide();
            });
        },
        onPageBeforeOut(){
            const self = this;
            const app = self.$f7;

            self.$store.dispatch('announcement/resetAnnouncement');
        },
        showMedia(item){
			const self = this;
			const app = self.$f7;

			const $$ = self.$$;

			if(item.medias != null){
                let medias = item.medias.map((x) => {
					if(['image/jpg', 'image/jpeg', 'image/png'].indexOf(x.mimetype) > -1){
						return x.url.original;
					}
				});
                let photoBrowser = app.photoBrowser.create({
                    photos: medias,
                    type: 'popup'
                }).open();
            }
		}
    }
}
</script>
